﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using Infragistics.Shared;

namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.Load += new EventHandler(Form1_Load);
            this.ultraGrid1.InitializeLayout += new InitializeLayoutEventHandler(ultraGrid1_InitializeLayout);
            this.ultraGrid1.BeforeColumnChooserDisplayed += new BeforeColumnChooserDisplayedEventHandler(ultraGrid1_BeforeColumnChooserDisplayed);
        }

        void ultraGrid1_BeforeColumnChooserDisplayed(object sender, BeforeColumnChooserDisplayedEventArgs e)
        {
            // Get the ColumnChooserGrid from the dialog
            ColumnChooserGrid grid = (ColumnChooserGrid)e.Dialog.ColumnChooserControl.Controls[0];
            // Check if we have already set our DrawFilter
            if (!(grid.DrawFilter is ColumnChooserDrawFilter))
            {
                // If we haven't Set Our DrawFilter;
                ColumnChooserDrawFilter drawFilter = new ColumnChooserDrawFilter();
                // We still want to use the default draw filter, the ColumnChooserDrawFilter will call this
                drawFilter.OriginalDrawFilter = grid.DrawFilter;
                grid.DrawFilter = drawFilter;
            }
        }

        void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Override.RowSelectorHeaderStyle = RowSelectorHeaderStyle.ColumnChooserButton;
            e.Layout.Override.RowSelectors = DefaultableBoolean.True;
        }

        void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = this.GetEmployees(24);
        }

        // Create sample data
        private DataTable GetEmployees(int count)
        {
            DataTable dtData = new DataTable("Employees");

            dtData.Columns.Add("EmployeeID", typeof(int));
            dtData.Columns.Add("Name", typeof(string));
            dtData.Columns.Add("OnSite", typeof(bool));
            dtData.Columns.Add("DateOfHire", typeof(DateTime));
            dtData.Columns.Add("Department", typeof(double));
            dtData.Columns.Add("Site", typeof(string));

            for (int i = 0; i < 8; i++)
            {
                dtData.Rows.Add(new object[] { i, string.Format("Name {0}", i), (i % 2 == 0), DateTime.Today.Date, i % 8, "http://www.google.com" });
            }

            dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

            return dtData;
        }

    }
}
