﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;

namespace WindowsFormsApplication2
{
    public class ColumnChooserDrawFilter:IUIElementDrawFilter
    {
        public IUIElementDrawFilter OriginalDrawFilter { get; set; }

        #region IUIElementDrawFilter Members

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            // Call the original draw filter
            bool retVal = this.OriginalDrawFilter.DrawElement(drawPhase, ref drawParams);
            
            // Check if this is before the BackColor is drawn
            if (drawPhase == DrawPhase.BeforeDrawBackColor && drawParams.Element is HeaderUIElement)
            {
                // Set the BackColor we want the headers on the column chooser to be drawn (this could be exposed as a property)
                drawParams.AppearanceData.BackColor = Color.Red;
                drawParams.AppearanceData.BackColor2 = Color.Red;
            }
            // return the return value for the original draw filter logic
            return retVal;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            // we want to return the original DrawFilters phase
            DrawPhase retVal = this.OriginalDrawFilter.GetPhasesToFilter(ref drawParams);
            
            // Check if this is a HeaderUIElement and if so we want to filter the BeforeDrawBackColor
            if (retVal == DrawPhase.None && drawParams.Element is HeaderUIElement)
            {
                retVal = DrawPhase.BeforeDrawBackColor;
            }
            return retVal;
        }

        #endregion
    }
}
